"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BountyDetail = exports.AsyncQtyButton = void 0;
const react_1 = require("@chakra-ui/react");
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const marketplace_sdk_1 = require("@strata-foundation/marketplace-sdk");
const react_2 = require("@strata-foundation/react");
const spl_token_bonding_1 = require("@strata-foundation/spl-token-bonding");
const spl_utils_1 = require("@strata-foundation/spl-utils");
const debounce_1 = __importDefault(require("lodash/debounce"));
const moment_1 = __importDefault(require("moment"));
const react_3 = __importStar(require("react"));
const ri_1 = require("react-icons/ri");
const AsyncButton_1 = require("../AsyncButton");
const AuthorityAndTokenInfo_1 = require("./AuthorityAndTokenInfo");
const BountyCardContribution_1 = require("./BountyCardContribution");
const DisburseFunds_1 = require("./DisburseFunds");
const TopHolders_1 = require("./TopHolders");
const AsyncQtyButton = ({ inputProps = {}, buttonProps = {}, action, children, validate, symbol, }) => {
    const [qty, setQty] = (0, react_3.useState)("");
    const validation = react_3.default.useMemo(() => validate && validate({ quantity: Number(qty) }), [validate, qty]);
    return (react_3.default.createElement(react_1.HStack, { w: "full", justify: "flex-start" },
        react_3.default.createElement(react_1.Box, { flexGrow: 1 },
            react_3.default.createElement(react_1.InputGroup, null,
                react_3.default.createElement(react_1.Input, Object.assign({ type: "number", value: qty, onChange: (e) => {
                        setQty(e.target.value);
                    } }, inputProps)),
                react_3.default.createElement(react_1.InputRightElement, { pr: "6px", fontSize: "16px", fontWeight: 700, color: "gray.500", justifyContent: "flex-end", width: "120px" }, symbol))),
        react_3.default.createElement(AsyncButton_1.AsyncButton, Object.assign({}, buttonProps, { action: () => action({ quantity: Number(qty) }), isDisabled: validation ? true : false }), validation ? validation : children)));
};
exports.AsyncQtyButton = AsyncQtyButton;
const BountyDetail = ({ name, description, image, mintKey, onEdit, }) => {
    var _a;
    const { info: tokenBonding, loading: bondingLoading } = (0, react_2.useTokenBondingFromMint)(mintKey);
    const { connected, publicKey } = (0, wallet_adapter_react_1.useWallet)();
    const targetMint = (0, react_2.useMint)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.targetMint);
    const { image: targetImage, metadata: targetMetadata, metadataKey, data: targetData, loading: targetMetaLoading, displayName, } = (0, react_2.useTokenMetadata)(mintKey);
    const { metadata: baseMetadata, loading: metadataLoading } = (0, react_2.useTokenMetadata)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.baseMint);
    const { pricing, loading: pricingLoading } = (0, react_2.useBondingPricing)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey);
    const { tokenBondingSdk } = (0, react_2.useStrataSdks)();
    const baseBalance = (0, react_2.useOwnedAmount)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.baseMint);
    const targetBalance = (0, react_2.useOwnedAmount)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.targetMint);
    const reserveAmount = (0, react_2.useReserveAmount)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey);
    const [isWithdraw, setIsWithdraw] = (0, react_3.useState)(false);
    const baseMint = (0, react_2.useMint)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.baseMint);
    // Debounce because this can cause it to flash a notification when reserves change at the
    // same time as bonding, but one comes through before the other.
    // eslint-disable-next-line react-hooks/exhaustive-deps
    const fundsHaveBeenUsed = (0, react_3.useMemo)((0, debounce_1.default)(() => tokenBonding &&
        baseMint &&
        reserveAmount &&
        (0, spl_token_bonding_1.toNumber)(tokenBonding.reserveBalanceFromBonding, baseMint) !==
            reserveAmount, 500), [tokenBonding, baseMint, reserveAmount]);
    const bountyClosed = (0, react_3.useMemo)(() => (0, debounce_1.default)(() => !tokenBonding && !bondingLoading, 200), [tokenBonding, bondingLoading]);
    // Stop the invocation of the debounced function
    // after unmounting
    (0, react_3.useEffect)(() => {
        return () => {
            bountyClosed.cancel();
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    const [topHolderKey, setTopHolderKey] = (0, react_3.useState)(0);
    const refreshTopHolders = () => setTopHolderKey((k) => k + 1);
    const attributes = react_3.default.useMemo(() => spl_utils_1.SplTokenMetadata.attributesToRecord(targetData === null || targetData === void 0 ? void 0 : targetData.attributes), [targetData]);
    const { info: governance } = (0, react_2.useGovernance)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.reserveAuthority);
    const isAdmin = (publicKey &&
        ((_a = tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.reserveAuthority) === null || _a === void 0 ? void 0 : _a.equals(publicKey))) ||
        governance;
    name = displayName || name;
    image = targetImage || image;
    description = (targetData === null || targetData === void 0 ? void 0 : targetData.description) || description;
    const dataMissing = (0, react_3.useMemo)(() => !name && !image && !description, [name, image, description]);
    if ((!targetMetaLoading && dataMissing) ||
        (attributes && !attributes.is_strata_bounty)) {
        return (react_3.default.createElement(react_1.Center, { height: "300px" },
            react_3.default.createElement(react_1.Text, null,
                react_3.default.createElement("b", null, "404: "),
                " Not found")));
    }
    if (dataMissing) {
        return react_3.default.createElement(react_1.Spinner, null);
    }
    const editVisible = (targetMetadata === null || targetMetadata === void 0 ? void 0 : targetMetadata.updateAuthority) &&
        targetMetadata.updateAuthority == (publicKey === null || publicKey === void 0 ? void 0 : publicKey.toBase58());
    return (react_3.default.createElement(react_1.VStack, { p: 2, spacing: 2, w: "full" },
        editVisible && (react_3.default.createElement(react_1.Button, { color: "gray.400", 
            // __hover={{ rounded: "lg", borderColor: "gray.200", backgroundColor: "gray.100" }}
            leftIcon: react_3.default.createElement(react_1.Icon, { as: ri_1.RiPencilFill, mr: "-1px" }), variant: "ghost", marginLeft: "auto", onClick: () => onEdit && onEdit() }, "Edit")),
        react_3.default.createElement(react_1.VStack, { w: "full", p: 6, pt: editVisible ? 0 : 8, spacing: 8 },
            react_3.default.createElement(react_1.VStack, { spacing: 4 },
                react_3.default.createElement(react_1.Heading, { textAlign: "center" }, name),
                react_3.default.createElement(AuthorityAndTokenInfo_1.AuthorityAndTokenInfo, { mintKey: mintKey }),
                tokenBonding && (react_3.default.createElement(react_1.Text, { fontSize: "15px", color: "gray.400" },
                    "Created",
                    " ",
                    (0, moment_1.default)(tokenBonding.goLiveUnixTime.toNumber() * 1000).fromNow()))),
            react_3.default.createElement(react_1.Text, { w: "full", align: "left", fontSize: "15px", color: "gray.500", whiteSpace: "pre-line" },
                description,
                "\n",
                (attributes === null || attributes === void 0 ? void 0 : attributes.discussion) && `Discussion: ${attributes.discussion}\n`,
                (attributes === null || attributes === void 0 ? void 0 : attributes.contact) && `Contact: ${attributes.contact}`),
            fundsHaveBeenUsed && (react_3.default.createElement(react_1.Alert, { status: "error" }, "Funds have been disbursed from this bounty without closing it. Existing contributors may not be able to withdraw what they put into the bounty. Contact the bounty authority if you have any questions")),
            !marketplace_sdk_1.MarketplaceSdk.isNormalBounty(tokenBonding) && (react_3.default.createElement(react_1.Alert, { status: "warning" }, "This bounty does not have normal bonding curve parameters. It may have royalties set, or be using a non fixed price curve. Buyer beware.")),
            bountyClosed() && (react_3.default.createElement(react_3.default.Fragment, null,
                react_3.default.createElement(react_1.Alert, { status: "info" }, "This bounty has been closed."),
                react_3.default.createElement(react_1.Divider, { color: "gray.200" }),
                react_3.default.createElement(react_1.Heading, { mb: "-6px", alignSelf: "flex-start", size: "sm" }, "Top Contributors"),
                react_3.default.createElement(TopHolders_1.TopHolders, { key: topHolderKey, mintKey: mintKey }))),
            !bountyClosed() && (react_3.default.createElement(react_3.default.Fragment, null,
                react_3.default.createElement(react_1.SimpleGrid, { w: "full", justify: "stretch", columns: [1, 1, 2], spacing: 2, gap: 2 },
                    react_3.default.createElement(BountyCardContribution_1.BountyCardContribution, { amount: reserveAmount, symbol: baseMetadata === null || baseMetadata === void 0 ? void 0 : baseMetadata.data.symbol }),
                    react_3.default.createElement(BountyCardContribution_1.BountyCardContribution, { amount: typeof targetBalance === "undefined"
                            ? undefined
                            : pricing === null || pricing === void 0 ? void 0 : pricing.sellTargetAmount(targetBalance), symbol: baseMetadata === null || baseMetadata === void 0 ? void 0 : baseMetadata.data.symbol, text: "My Contributions" })),
                react_3.default.createElement(react_1.VStack, { align: "flex-end", w: "full" },
                    react_3.default.createElement(exports.AsyncQtyButton, { buttonProps: {
                            colorScheme: "primary",
                            w: "180px",
                        }, symbol: baseMetadata === null || baseMetadata === void 0 ? void 0 : baseMetadata.data.symbol, validate: ({ quantity }) => {
                            if (isWithdraw) {
                                if (pricing) {
                                    const actualQuantity = -pricing.buyWithBaseAmount(-quantity);
                                    if (!targetBalance || targetBalance < actualQuantity) {
                                        return "Insufficient funds";
                                    }
                                    if (!connected) {
                                        return "Connect Wallet";
                                    }
                                }
                                return null;
                            }
                            else {
                                if (!baseBalance || baseBalance < quantity) {
                                    return "Insufficient funds";
                                }
                                if (!connected) {
                                    return "Connect Wallet";
                                }
                            }
                            return null;
                        }, action: ({ quantity }) => __awaiter(void 0, void 0, void 0, function* () {
                            if (isWithdraw && pricing) {
                                yield (tokenBondingSdk === null || tokenBondingSdk === void 0 ? void 0 : tokenBondingSdk.sell({
                                    targetAmount: -pricing.buyWithBaseAmount(-quantity),
                                    tokenBonding: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey,
                                    slippage: 0,
                                }));
                            }
                            else if (!isWithdraw) {
                                yield (tokenBondingSdk === null || tokenBondingSdk === void 0 ? void 0 : tokenBondingSdk.buy({
                                    baseAmount: quantity,
                                    tokenBonding: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey,
                                    slippage: 0,
                                }));
                            }
                            refreshTopHolders();
                        }) }, isWithdraw ? "Withdraw Funds" : "Contribute Funds"),
                    react_3.default.createElement(react_1.Button, { onClick: () => setIsWithdraw(!isWithdraw), fontWeight: 400, w: "180px", variant: "link", size: "sm", colorScheme: "primary" }, isWithdraw ? "Contribute Funds" : "Withdraw Funds")),
                react_3.default.createElement(react_1.Divider, { color: "gray.200" }),
                react_3.default.createElement(react_1.Heading, { mb: "-6px", alignSelf: "flex-start", size: "sm" }, "Top Contributors"),
                react_3.default.createElement(TopHolders_1.TopHolders, { key: topHolderKey, mintKey: mintKey }),
                isAdmin && tokenBonding && (react_3.default.createElement(react_1.VStack, { w: "full", spacing: 2 },
                    react_3.default.createElement(react_1.Divider, { color: "gray.200" }),
                    react_3.default.createElement(react_1.Heading, { alignSelf: "flex-start", size: "sm" }, "Disburse Funds"),
                    react_3.default.createElement(DisburseFunds_1.DisburseFunds, { tokenBondingKey: tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey }))))))));
};
exports.BountyDetail = BountyDetail;
//# sourceMappingURL=BountyDetail.js.map